﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using projectDoubleDeckerBus.Entity;
using System.Drawing;
using System.Collections.Generic;

namespace projectDoubleDeckerBus.Drawings
{
    public class DrawningDoubleDeckerBus : DrawningBus
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="wing">Признак наличия антикрыла</param>
        /// <param name="sportLine">Признак наличия гоночной полосы</param>
        /// <param name="width">Ширина картинки</param>
        /// <param name="height">Высота картинки</param>
        public DrawningDoubleDeckerBus(int speed, double weight, Color bodyColor, Color
        additionalColor, bool floor, bool tailpipe, int width, int height) :

        base(speed, weight, bodyColor, width, height, 172, 112)
        {
            if (EntityBus != null)
            {
                EntityBus = new EntityDoubleDeckerBus(speed, weight, bodyColor,
                additionalColor, floor, tailpipe);
            }
        }
        public override void DrawTransport(Graphics g)
        {
            if (EntityBus is not EntityDoubleDeckerBus doubleDeckerBus)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush additionalBrush = new
            SolidBrush(doubleDeckerBus.AdditionalColor);
            /// <summary>
            /// Прорисовка объекта
            /// </summary>
            /// <param name="g"></param>
            /// 
            int windowSize = 15;

            if (doubleDeckerBus.Floor)
            {
                g.DrawEllipse(pen, _startPosX + 46, _startPosY + 10, windowSize, windowSize);
                g.DrawEllipse(pen, _startPosX + 62, _startPosY + 10, windowSize, windowSize);
                g.DrawEllipse(pen, _startPosX + 100, _startPosY + 10, windowSize, windowSize);

                g.DrawEllipse(pen, _startPosX + 115, _startPosY + 10, windowSize, windowSize);
                g.DrawEllipse(pen, _startPosX + 130, _startPosY + 10, windowSize, windowSize);
                g.DrawEllipse(pen, _startPosX + 145, _startPosY + 10, windowSize, windowSize);

                g.FillRectangle(additionalBrush, _startPosX + 40,
                _startPosY + 2, 130, 32);

                Brush brBlue1 = new SolidBrush(Color.LightBlue);
                g.FillEllipse(brBlue1, _startPosX + 46, _startPosY + 10, windowSize, windowSize);
                g.FillEllipse(brBlue1, _startPosX + 62, _startPosY + 10, windowSize, windowSize);
                g.FillEllipse(brBlue1, _startPosX + 100, _startPosY + 10, windowSize, windowSize);
                g.FillEllipse(brBlue1, _startPosX + 115, _startPosY + 10, windowSize, windowSize);
                g.FillEllipse(brBlue1, _startPosX + 130, _startPosY + 10, windowSize, windowSize);
                g.FillEllipse(brBlue1, _startPosX + 145, _startPosY + 10, windowSize, windowSize);
            }

            if (doubleDeckerBus.Tailpipe)
            {
                g.FillRectangle(additionalBrush, _startPosX, _startPosY + 76, 40, 10);

            }
            base.DrawTransport(g);
        }
        public void setAddColor(Color color)
        {
            if (EntityBus is EntityDoubleDeckerBus doubledeckerbus)
            {
                doubledeckerbus.setAddColor(color);
            }

        }
    }
}
