﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using projectDoubleDeckerBus.Entity;
using projectDoubleDeckerBus.Drawings;
using projectDouble_Decker_Bus.MovementStrategy;

namespace projectDoubleDeckerBus
{
    public partial class FormBusConfig : Form
    {   
        DrawningBus? _bus = null;
        private event Action<DrawningBus> EventAddBus;
        public FormBusConfig()
        {
            InitializeComponent();
            panelBlack.MouseDown += PanelColor_MouseDown;
            panelPurple.MouseDown += PanelColor_MouseDown;
            panelGray.MouseDown += PanelColor_MouseDown;
            panelBlue.MouseDown += PanelColor_MouseDown;
            panelWhite.MouseDown += PanelColor_MouseDown;
            panelYellow.MouseDown += PanelColor_MouseDown;
            panelGreen.MouseDown += PanelColor_MouseDown;
            panelRed.MouseDown += PanelColor_MouseDown;
            buttonCancel.Click += (s, e) => Close();
        }
        private void DrawCar()
        {
            Bitmap bmp = new Bitmap(pictureBoxObject.Width, pictureBoxObject.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _bus?.SetPosition(5, 5);
            if (_bus is DrawningBus)
                (_bus as DrawningBus).DrawTransport(gr);
            else
                _bus?.DrawTransport(gr);
            pictureBoxObject.Image = bmp;
        }
        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Panel)?.DoDragDrop((sender as Panel)?.BackColor,
            DragDropEffects.Move | DragDropEffects.Copy);
        }
        private void LabelColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(Color)))
                e.Effect = DragDropEffects.Copy;
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
        private void LabelColor_DragDrop(object sender, DragEventArgs e)
        {

            if (_bus is DrawningBus bus)
            {
                LabelColor.BackColor = (Color)e.Data.GetData(typeof(Color));
                _bus.setColor((Color)e.Data.GetData(typeof(Color)));
            }
            DrawCar();
        }
        private void LabelAddColor_DragDrop(object sender, DragEventArgs e)
        {
            if (_bus is DrawningDoubleDeckerBus bus)
            {
                labelAddColor.BackColor = (Color)e.Data.GetData(typeof(Color));
                bus.setAddColor((Color)e.Data.GetData(typeof(Color)));
            }
            DrawCar();
        }
        private void LabelObject_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Label)?.DoDragDrop((sender as Label)?.Name,
        DragDropEffects.Move | DragDropEffects.Copy);

        }
        private void PanelObject_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data?.GetDataPresent(DataFormats.Text) ?? false)
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }

        }
        private void PanelObject_DragDrop(object sender, DragEventArgs e)
        {
            switch (e.Data?.GetData(DataFormats.Text).ToString())
            {
                case "labelSimpleObject":
                    _bus = new DrawningBus((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White, 900,
                   500);
                    LabelColor.BackColor = Color.White;
                    labelAddColor.BackColor = Color.Transparent;
                    break;
                case "labelModifiedObject":
                    _bus = new DrawningDoubleDeckerBus((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White, Color.Black, checkBoxFloor.Checked,
                   checkBoxTailpipe.Checked, 900,
                  500);
                    LabelColor.BackColor = Color.White;
                    labelAddColor.BackColor = Color.Black;
                    break;
            }

            DrawCar();
        }
        public void AddEvent(Action<DrawningBus> ev)
        {
            if (EventAddBus == null)
            {
                EventAddBus = ev;
            }
            else
            {
                EventAddBus += ev;
            }
        }
        private void buttonAdd_Click(object sender, EventArgs e)
        {
            EventAddBus?.Invoke(_bus);
            Close();
        }
    }
}
